// Ŀ
//                                                                       
//  This file contains all the C header information for                  
//  3D-Ware Version 1.0                                                  
//                                                                       
//  for RealMode DOS versions of the Library.                            
//                                                                       
//  All information contained herein is                                  
//  (C) 1994 Virtek International Corporation                            
//                                                                       
//  The License agreement covers Use of 3D-Ware and this header file.    
//                                                                       
// 

// Ŀ
//                                                                       
//   Standard 3D-Ware definitions here                                   
//                                                                       
// 

#define  DRW_SIMPLE            0
#define  DRW_MOBILE            2
#define  DRW_WHITE_SIMPLE      4
#define  DRW_WHITE_MOBILE      6
#define  DRW_FLASH_SIMPLE      8
#define  DRW_FLASH_MOBILE      10
#define  DRW_SILHOUETTE        12
#define  DRW_USING_UMAT        14

#define  BUTTON_LEFT           1
#define  BUTTON_RIGHT          2
#define  BUTTON_MS_MIDDLE      (BUTTON_RIGHT | BUTTON_LEFT)
#define  BUTTON_MIDDLE         4


#define  _ESC                  0x01
#define  _1                    0x02
#define  _2                    0x03
#define  _3                    0x04
#define  _4                    0x05
#define  _5                    0x06
#define  _6                    0x07
#define  _7                    0x08
#define  _8                    0x09
#define  _9                    0x0A
#define  _0                    0x0B
#define  _MINUS                0x0C
#define  _EQUALS               0x0D
#define  _BACKSPACE            0x0E
#define  _TAB                  0x0F
#define  _Q                    0x10
#define  _W                    0x11
#define  _E                    0x12
#define  _R                    0x13
#define  _T                    0x14
#define  _Y                    0x15
#define  _U                    0x16
#define  _I                    0x17
#define  _O                    0x18
#define  _P                    0x19
#define  _OP_SQ_BRK            0x1A
#define  _CL_SQ_BRK            0x1B
#define  _RETURN               0x1C
#define  _CONTROL              0x1D
#define  _A                    0x1E
#define  _S                    0x1F
#define  _D                    0x20
#define  _F                    0x21
#define  _G                    0x22
#define  _H                    0x23
#define  _J                    0x24
#define  _K                    0x25
#define  _L                    0x26
#define  _SEMICOLON            0x27
#define  _QUOTE                0x28
#define  _L_SHIFT              0x2A
#define  _HASH                 0x2B
#define  _Z                    0x2C
#define  _X                    0x2D
#define  _C                    0x2E
#define  _V                    0x2F
#define  _B                    0x30
#define  _N                    0x31
#define  _M                    0x32
#define  _COMMA                0x33
#define  _FULL_STOP            0x34
#define  _SLASH                0x35
#define  _R_SHIFT              0x36
#define  _ALTERNATE            0x38
#define  _SPACE                0x39
#define  _CAPS_LOCK            0x3A
#define  _F1                   0x3B
#define  _F2                   0x3C
#define  _F3                   0x3D
#define  _F4                   0x3E
#define  _F5                   0x3F
#define  _F6                   0x40
#define  _F7                   0x41
#define  _F8                   0x42
#define  _F9                   0x43
#define  _F10                  0x44
#define  _K_HOME               0x47
#define  _K_UP_ARROW           0x48
#define  _K_PGUP               0x49
#define  _K_MINUS              0x4A
#define  _K_LF_ARROW           0x4B
#define  _K_RT_ARROW           0x4D
#define  _K_PLUS               0x4E
#define  _K_DN_ARROW           0x50
#define  _K_PGDN               0x51
#define  _K_INSERT             0x52
#define  _K_DELETE             0x53
#define  _BACKSLASH            0x56
#define  _K_SLASH              0x35
#define  _K_STAR               0x37
#define  _K_7                  0x47
#define  _K_8                  0x48
#define  _K_9                  0x49
#define  _K_4                  0x4B
#define  _K_5                  0x4C
#define  _K_6                  0x4D
#define  _K_1                  0x4F
#define  _K_2                  0x50
#define  _K_3                  0x51
#define  _K_0                  0x52
#define  _K_FULLSTOP           0x53
#define  _K_ENTER              0x37
#define  _K_END                0x4F
#define  _INSERT               0x62
#define  _DELETE               0x63
#define  _DN_ARROW             0x64
#define  _PGDN                 0x65
#define  _HOME                 0x67
#define  _UP_ARROW             0x68
#define  _PGUP                 0x69
#define  _LF_ARROW             0x6B
#define  _RT_ARROW             0x6D
#define  _END                  0x6F
#define  _NUMLOCK              0x45


#define  dddVGA                0
#define  dddGLASSES_3DTV       1
#define  dddCYBERMAXX          2
#define  dddVFX1               3
#define  dddMagicMediaHMD      4
#define  dddIGlasses           5

#define  dddmono               0
#define  dddstereo             1

#define  dddleft               0
#define  dddright              1
#define  dddboth               2


// Ŀ
//                                                                       
//  3D-Ware structure definitions.                                       
//                                                                       
// 


struct ddddisplay_device_structure {
        short                       display_type;
        short                       X_resolution;
        short                       Y_resolution;
        short                       num_colours;
        short                       output_port;
        short                       mode;
};


struct PositionStructure {
        long                        Xpos;
        long                        Ypos;
        long                        Zpos;
};

struct AngleStructure {
        short                       Xangle;
        short                       Yangle;
        short                       Zangle;
};

struct LookAtStructure {
        long                        Xpos;
        long                        Ypos;
        long                        Zpos;
        short                       Xangle;
        short                       Yangle;
        short                       Zangle;
        long                        Distance;
};

struct LookAtStructure16 {
        short                       Xpos;
        short                       Ypos;
        short                       Zpos;
        short                       Xangle;
        short                       Yangle;
        short                       Zangle;
        short                       Distance;
};

struct ObjectStructure16 {
        short                       Xpos;
        short                       Ypos;
        short                       Zpos;
        short                       Xangle;
        short                       Yangle;
        short                       Zangle;
        short                       ShapeHandle;
        short                       ShapeFlags;
        short                       DrawRoutine;
};

struct ObjectStructure {
        long                        Xpos;
        long                        Ypos;
        long                        Zpos;
        short                       Xangle;
        short                       Yangle;
        short                       Zangle;
        short                       ShapeHandle;
        short                       ShapeFlags;
        short                       DrawRoutine;
};

struct ViewerStructure {
        long                        Xpos;
        long                        Ypos;
        long                        Zpos;
        short                       Xangle;
        short                       Yangle;
        short                       Zangle;
};

struct ViewerStructure16 {
        short                       Xpos;
        short                       Ypos;
        short                       Zpos;
        short                       Xangle;
        short                       Yangle;
        short                       Zangle;
};

struct dddTrackerStructure {
        short                       Xangle;
        short                       Yangle;
        short                       Zangle;
};



// Ŀ
//                                                                       
//  3D-Ware variable definitions.                                        
//                                                                       
// 

extern  char                   far  dddbuttons;
extern  char                   far  dddcurrent_page;
extern  long                   far  dddceiling;
extern  short                  far  dddcollision_angles [2];
extern  short                  far  dddcollision_indices [2];
extern  short                  far  dddcosine[];
extern  short                  far  dddems_requested;
extern  volatile char          far  dddextended_code;
extern  long                   far  dddfloor;
extern  unsigned short         far  dddmax_sprite_height;
extern  unsigned short         far  dddmax_sprite_width;
extern  short                  far  dddscale_sprite_buffer;
extern  short                  far  dddsine[];
extern  short                  far  dddViewerXpos16;
extern  short                  far  dddViewerXpos_32;
extern  short                  far  dddViewerYpos16;
extern  short                  far  dddViewerYpos_32;
extern  short                  far  dddViewerZpos16;
extern  short                  far  dddViewerZpos_32;
extern  short                  far  dddglobal_midx;
extern  short                  far  dddglobal_midy;
extern  short                  far  dddglobal_xmax;
extern  short                  far  dddglobal_xmin;
extern  short                  far  dddglobal_ymax;
extern  short                  far  dddglobal_ymin;
extern  short                  far  dddgravis_handle;
extern  short                  far  dddgravis_port;
extern  long                   far  dddsample_addrs [255];
extern  long                   far  dddsample_lens [255];
extern  short                  far  dddsample_vols [255];
extern  short                  far  dddvmat [3][3];
extern  short                  far  dddIPDXOffset;
extern  short                  far  dddIPDYOffset;
extern  short                  far  dddIPDZOffset;
extern  char                   far  init_status;
extern  short                  far  dddIsMouse;
extern  char                   far  dddjoystick_left_button;
extern  char                   far  dddjoystick_right_button;
extern  short                  far  dddjoystick_x_position;
extern  short                  far  dddjoystick_y_position;
extern  volatile char          far  dddkeycode;
extern  volatile char          far  dddkeydown;
extern  volatile char          far  dddkeypressed[];
extern  char                   far  dddlbutton;
extern  unsigned short         far  dddlogbase;
extern  char far *             far  mouse_sprite;
extern  char far *             far  mouse_buffer;
extern  short                  far  MOUSE_H;
extern  short                  far  MOUSE_W;
extern  short                  far  dddmouse_x;
extern  short                  far  MOUSE_X_OFF;
extern  short                  far  dddmouse_y;
extern  short                  far  MOUSE_Y_OFF;
extern  char                   far  dddrbutton;
extern  unsigned short         far  dddrowtable[];
extern  char                   far  dddscan_2_ascii[];
extern  long                   far  Seed;
extern  unsigned char          far  dddstandardpal[];
extern  short                  far  dddumat [3][3];
extern  unsigned char          far  ddduserpal[];
extern  short                  far  dddUserXpos;
extern  short                  far  dddUserYpos;
extern  short                  far  dddUserZpos;


// Ŀ
//                                                                       
//  3D-Ware function definitions.                                        
//                                                                       
// 

extern  void            pascal far  dddAlign(void far *angle, void far *target, void far *source);
extern  void            pascal far  dddAlign16(void far *angle, void far *target, void far *source);
extern  short           pascal far  dddAtan(short dx, short dz);
extern  void            pascal far  dddBlackPalette(void);
extern  void            pascal far  dddBox(short Color, short Xpos, short Ypos, short X1pos, short Y1pos);
extern  void            pascal far  dddClearClipArea(void);
extern  void            pascal far  dddClearObjects(void);
extern  void            pascal far  dddClearScreenBuffer(void);
extern  void            pascal far  dddClearScreenBuffer2(void);
extern  void            cdecl  far  dddClipDrawLine(short Color, short Xpos, short Ypos, short X1pos, short Y1pos);	// HAS to be a cdecl.
extern  void            cdecl  far  dddClipDrawStipLine(short Color, short pattern, short Xpos, short Ypos, short X1pos, short Y1pos);	// HAS to be a cdecl.
extern  void            pascal far  dddClose3d(void);
extern  void            pascal far  dddCls(void);
extern  short           pascal far  dddCmpsPal(void far *palette);	
extern  void            pascal far  dddCopyLogbase2Memory(short Xpos, short Ypos, short Width, short Height, void far *buffer);
extern  void            pascal far  dddCopyLogbase2ScreenBuffer(void);
extern  void            pascal far  dddCopyLogbase2ScreenBuffer2(void);
extern  void            pascal far  dddCopyMemory2Logbase(short Xpos, short Ypos, short width, short height, void far *image_data);
extern  void            pascal far  dddCopyMemory2ScreenBuffer(char far *memptr);
extern  void            pascal far  dddCopyMemory2ScreenBuffer2(char far *memptr);
extern  void            pascal far  dddCopyScreenBuffer2Logbase(void);
extern  void            pascal far  dddCopyScreenBuffer22Logbase(void);
extern  void            pascal far  dddDosPrint(char far *text);
extern  void            pascal far  dddDotGrid(void);
extern  void            pascal far  dddDrawGraphicsMouse(void);
extern  void            pascal far  dddDrawLine(char Color, short Xpos, short Ypos, short X1pos, short Y1pos);
extern  void            pascal far  dddDrawObjects(void);
extern  void            pascal far  dddDrawPoly(void far *poly_struct);
extern  void            pascal far  dddDrawSpecialPoly(void far *patt_struct);
extern  void            pascal far  dddDrawStipLine(char Color, char pattern, short Xpos, short Ypos, short X1pos, short Y1pos);
extern  void            pascal far  dddEmmRelease(void);
extern  void            pascal far  dddFade(unsigned char far *palette);
extern  void            pascal far  dddFadeDown(unsigned char far *palette);
extern  void            pascal far  dddFadeTo(unsigned char far *new_palette);
extern  void            pascal far  dddFatalError(char far *message);
extern  void            pascal far  dddFclose(short filehandle);
extern  short           pascal far  dddFcreate(char far *filename);
extern  long            pascal far  dddFileSize(short filehandle);
extern  void            pascal far  dddFillClipArea(short Color);
extern  void            pascal far  dddFillScreen(short Color);
extern  short           pascal far  dddFopen(char far *filename);
extern  long            pascal far  dddFread(void huge *buffer,short numbytes,short handle);
extern  long            pascal far  dddFseek(long offset ,short method ,short filehandle);
extern  long            pascal far  dddFwrite(void huge *buffer,short numbytes,short filehandle);
extern  void            pascal far  dddGamePrint3(char Color, short Xpos, short Ypos, char far *text);
extern  void            pascal far  dddGamePrint5(char Color, short Xpos, short Ypos, char far *text);
extern  char far *      pascal far  dddGetEnvSeg(void);
extern  long            pascal far  dddGetFileSize(char far *filename);
extern  long            pascal far  dddGeticks(void);
extern  void            pascal far  dddGetJoystickPos(void);
extern  short           pascal far  dddGetMode(void);
extern  void            pascal far  dddGetMousePos(void);
extern  void            pascal far  dddGetRelXYZ(short Xorigin, short Yorigin, short Zorigin);
extern  long            pascal far  dddGetRnd(void);
extern  long            pascal far  dddGetScreenBufferAddress(void);
extern  long            pascal far  dddGetScreenBuffer2Address(void);
extern  char far *      pascal far  dddGetShapePaletteName(short shapehandle);
extern  short           pascal far  dddGetShapeSize(unsigned short shapehandle);
extern  short           pascal far  dddGravisInit(short num_voices);
extern  void            pascal far  dddHideGraphicsMouse(void);
extern  void            pascal far  dddHoriFade(unsigned short vx, unsigned short vz);
extern  void            pascal far  dddHorizon(unsigned short vx, unsigned short vz);
extern  void            pascal far  dddHsync(void);
extern  void            pascal far  dddInit3d(void);
extern  void            pascal far  dddInitAll(void);
extern  void            pascal far  dddInitKeybd(void);
extern  short           pascal far  dddInitMouse(void);
extern  void            pascal far  dddInitTimer(void);
extern  void            pascal far  dddInitVideo(void);
extern  short           pascal far  dddInsertObject(char style, short shapehandle, char flags, long Xpos, long Ypos, long Zpos, short Xangle, short Yangle, short Zangle);
extern  short           pascal far  dddInsertObject16(char style, short shapehandle, char flags, short Xpos, short Ypos, short Zpos, short Xangle, short Yangle, short Zangle);
extern  void            pascal far  dddIPDOffset(short ipd);
extern  short           pascal far  dddIsCollision(struct ObjectStructure far *, struct ObjectStructure far *);
extern  short           pascal far  dddIsCollision16(struct ObjectStructure16 far *, struct ObjectStructure16 far *);
extern  short           pascal far  dddIsGravis(void);
extern  short           pascal far  dddIsVGA(void);
extern  short           pascal far  dddJoystickPresent(void);
extern  void            pascal far  dddLineBox(short Color, short X1pos, short Y1pos, short X2pos, short Y2pos);
extern  void            pascal far  dddLineOff(void);
extern  void            pascal far  dddLineOn(short Color);
extern  void            pascal far  dddLoadColors(char far *filename);
extern  void            pascal far  dddLookAt(long x,long y,long z,short vx,short vy,short vz,short distance);
extern  void            pascal far  dddLookAt16(short x,short y,short z,short vx,short vy,short vz,short distance);
extern  void            pascal far  dddMaskSprite(void far *Spritefile, short spr_num, short Xpos, short Ypos);
extern  void            pascal far  dddMedPrint(char Colour, short Xpos, short Ypos, char far *string);
extern  void            pascal far  dddMedPrintC(char Colour, short Ypos, char far *string);
extern  char far *      pascal far  dddMemCpy(char far *dest, char far *src, short length);
extern  short           pascal far  dddMouseGetButtons(void);
extern  void            pascal far  dddMouseGetPointerXy(short far *x, short far  *y, short far  *b);
extern  void            pascal far  dddMouseGetRelPointerXy(short far *x, short far *y);
extern  void            pascal far  dddMouseHidePointer(void);
extern  void            pascal far  dddMouseShowPointer(void);
extern  short           pascal far  dddOpenReadClose(char far *filename,void far *buffer);
extern  void            pascal far  dddPlot(short colour, short Xpos, short Ypos);
extern  void            pascal far  dddPrint3x10(char color, short Xpos ,short Ypos, char far *text);
extern  void            pascal far  dddPrint3x5(char color, short Xpos, short Ypos, char far *text);
extern  void            pascal far  dddPrint6(char color, short Xpos, short Ypos, char far *text);
extern  void            pascal far  dddPrint7(char color, short Xpos, short Ypos, char far *text);
extern  void            pascal far  dddProjectForward16(void far *pos,void far *ang,short speed);
extern  void            pascal far  dddProjectForward(void far *pos,void far *ang,short speed);
extern  short           pascal far  dddQInsertObject(struct ObjectStructure far *instance);
extern  short           pascal far  dddQInsertObject16(struct ObjectStructure16 far *instance);
extern  void            pascal far  dddQLookAt(struct LookAtStructure far *instance);
extern  void            pascal far  dddQLookAt16(struct LookAtStructure16 far *instance);
extern  short           pascal far  dddReadFile(char far * target, char far * filename);
extern  short           pascal far  dddReadIff(char far *filename);
extern  short           pascal far  dddReadIffPalette(char far *filename);
extern  void            pascal far  dddReadJoystick(void);
extern  void            pascal far  dddReadMousePosition(void);
extern  short           pascal far  dddReadPcx(char far *filename);
extern  short           pascal far  dddReadPcxPalette(char far *filename);
extern  unsigned char   pascal far  dddReadPix(short Xpos, short Ypos);
extern  short           pascal far  dddReadRaw(char far *filename);
extern  long            pascal far  dddReadTimer(void);
extern  short far *     pascal far  dddReadTracker(struct dddTrackerStructure far *instance);
extern  short far *     pascal far  dddReadVfx1Tracker(void);
extern  long            pascal far  dddRealGetFileSize(char far *filename);
extern  void            pascal far  dddResetRnd(void);
extern  void            pascal far  dddResetVfx1(void);
extern  void            pascal far  dddResetTracker(void);
extern  void            pascal far  dddRestoreAll(void);
extern  void            pascal far  dddRestoreKeybd(void);
extern  void            pascal far  dddRestoreTimer(void);
extern  void            pascal far  dddRestoreVideo(void);
extern  unsigned short  pascal far  dddRnd(void);
extern  void            pascal far  dddRotateXY(short far *xyout, short x,short y);
extern  void            pascal far  dddRotateXYZ(short far *source,short far *destination);
extern  void            pascal far  dddSameOn(short col);
extern  void            pascal far  dddSameOff(void);
extern  void            pascal far  dddSave3dShape(short ShapeHandle,char far *filename);
extern  void            pascal far  dddScreenSwap(void);
extern  void            pascal far  dddSelectEmmAmount(short amount);
extern  void            pascal far  dddSelectEye(short eye);
extern  void            pascal far  dddSelectTracker(short hmdtype);
extern  void            pascal far  dddSet2dRotation(short angle);
extern  void            pascal far  dddSet3dRotation(unsigned short xang,unsigned short yang,unsigned short zang);
extern  void            pascal far  dddSetCenter(short midx,short midy,short xmax,short ymax);
extern  void            pascal far  dddSetClipArea(short xmin, short xmax, short ymin, short ymax);
extern  void            pascal far  dddSetDefaultMouseCursor(void);
extern  void            pascal far  dddSetDepthFade(short shift);
extern  void            pascal far  dddSetDotGrid(short midx,short midy,short xmax,short ymax);
extern  short           pascal far  dddSetDisplayDevice(struct ddddisplay_device_structure far *instance);
extern  void            pascal far  dddSetFileIntercept(void far *exists, void far *open, void far *read, void far *close, void far *getfilesize, void far *seek, void far *write, void far *create);
extern  void            pascal far  dddSetHorizonClip(short xmin, short xmax, short ymin, short ymax, short yim);
extern  void            pascal far  dddSetLogbase(char page);
extern  void            pascal far  dddSetLogbase2CurrentDisplay(void);
extern  void            pascal far  dddSetLogbase2ScreenBuffer(void);
extern  void            pascal far  dddSetLogbase2ScreenBuffer2(void);
extern  short           pascal far  dddSetMode(short mode);
extern  void            pascal far  dddSetMouseClip(short minx, short maxx, short miny, short maxy);
extern  void            pascal far  dddSetMouseCursor(char far *msprite,char far *mbuffer,short xoff,short yoff,short width,short height,short xside,short yside);
extern  void            pascal far  dddSetActivePage(char page);
extern  void            pascal far  dddSetPal(unsigned char far *palette);
extern  void            pascal far  dddSetRnd(long seed);
extern  short           pascal far  dddSetShapePaletteName(short shapehandle, char far * pallettename);
extern  void            pascal far  dddSetSpriteClip(short left, short right, short top, short bottom);
extern  short           pascal far  dddSetStandardPalFromIff(char far *filename);
extern  short           pascal far  dddSetStandardPalFromPcx(char far *filename);
extern  short           pascal far  dddSetupDatabase(char far * filename, char far *memory, short memsize);
extern  void            pascal far  dddSetViewAngles(short xang, short yang, short zang);
extern  void            pascal far  dddSetViewPos16(short x, short y, short z);
extern  void            pascal far  dddSetViewPos(long x, long y, long z);
extern  unsigned short  pascal far  dddShapeLoad(char far * shape_name);
extern  void            pascal far  dddShowGraphicsMouse(void);
extern  unsigned short  pascal far  dddSquareRoot(unsigned long n);
extern  char far *      pascal far  dddStrCat(char far * dest, char far * src);
extern  char far *      pascal far  dddStrChr(char far *string, short ch);
extern  short           pascal far  dddStrCmp(char far * string1, char far * string2);
extern  char far *      pascal far  dddStrCpy(char far * dest, char far * src);
extern  short           pascal far  dddStrLen(char far *string);
extern  char far *      pascal far  dddStrLwr(char far *string);
extern  char far *      pascal far  dddStrUpr(char far *string);
extern  char far *      pascal far  dddStrnCpy(char far * dest, char far * src, short numbytes);
extern  char far *      pascal far  dddStrnSet(char far *dest, short value, short num);
extern  void            pascal far  dddSubBox(short color, short X1, short Y1, short X2, short Y2);
extern  void            pascal far  dddUpdateGraphicsMouse(void);
extern  void            pascal far  dddVsync(void);
extern  short           pascal far  dddWhatCPU(void);
extern  void            pascal far  dddWhitePalette(void);
extern  short           pascal far  dddWriteFile(char far *filename,void far *buffer,long size);
extern  void            pascal far  dddWriteIff(char far *fname, char far *pal, short flg);
extern  void            pascal far  dddWritePcx(char far *fname, char far *palette);
extern  void            pascal far  dddXBox(short color, short Xpos, short Ypos, short X1pos, short Y1pos);


extern  short           pascal far  dddTestForIpx(void);



struct ddddisplay_device_structure VGA320_200_256    ={ dddVGA,
                                                     320,
                                                     200,
                                                     256,
                                                     0,
                                                     dddmono};

struct ddddisplay_device_structure VGA320_240_256    ={ dddVGA,
                                                     320,
                                                     240,
                                                     256,
                                                     0,
                                                     dddmono};

struct ddddisplay_device_structure VGA320_350_256    ={ dddVGA,
                                                     320,
                                                     350,
                                                     256,
                                                     0,
                                                     dddmono};

struct ddddisplay_device_structure VGA320_400_256    ={ dddVGA,
                                                     320,
                                                     400,
                                                     256,
                                                     0,
                                                     dddmono};

struct ddddisplay_device_structure GLASSES_3DTV_COM1 ={ dddGLASSES_3DTV,
                                                     320,
                                                     200,
                                                     256,
                                                     0,
                                                     dddstereo};

struct ddddisplay_device_structure GLASSES_3DTV_COM2 ={ dddGLASSES_3DTV,
                                                     320,
                                                     200,
                                                     256,
                                                     1,
                                                     dddstereo};

struct ddddisplay_device_structure GLASSES_3DTV_COM3 ={ dddGLASSES_3DTV,
                                                     320,
                                                     200,
                                                     256,
                                                     2,
                                                     dddstereo};

struct ddddisplay_device_structure GLASSES_3DTV_COM4 ={ dddGLASSES_3DTV,
                                                     320,
                                                     200,
                                                     256,
                                                     3,
                                                     dddstereo};

struct ddddisplay_device_structure GLASSES_3DTV_LPT1 ={ dddGLASSES_3DTV,
                                                     320,
                                                     200,
                                                     256,
                                                     4,
                                                     dddstereo};

struct ddddisplay_device_structure GLASSES_3DTV_LPT2 ={ dddGLASSES_3DTV,
                                                     320,
                                                     200,
                                                     256,
                                                     5,
                                                     dddstereo};

struct ddddisplay_device_structure CYBERMAXX_HMD_M   ={ dddCYBERMAXX,
                                                     320,
                                                     200,
                                                     256,
                                                     0,
                                                     dddmono};

struct ddddisplay_device_structure CYBERMAXX_HMD_S   ={ dddCYBERMAXX,
                                                     320,
                                                     200,
                                                     256,
                                                     0,
                                                     dddstereo};

struct ddddisplay_device_structure I_GLASSES_L_M     ={ dddIGlasses,
                                                     320,
                                                     200,
                                                     256,
                                                     0,
                                                     dddmono};

struct ddddisplay_device_structure I_GLASSES_H_M     ={ dddIGlasses,
                                                     320,
                                                     400,
                                                     256,
                                                     0,
                                                     dddmono};

struct ddddisplay_device_structure I_GLASSES_L_S     ={ dddIGlasses,
                                                     320,
                                                     200,
                                                     256,
                                                     0,
                                                     dddstereo};

struct ddddisplay_device_structure I_GLASSES_H_S     ={ dddIGlasses,
                                                     320,
                                                     400,
                                                     256,
                                                     0,
                                                     dddstereo};





// These are not supported but do exist.

struct GravisInfo {
        long                        Address;
        long                        Length;
        short                       Freq;
        short                       Pan;
        short                       Volume;
};

extern  short           pascal far  dddGravisLoadSound(char far *filename, short type, short bits);
extern  void            pascal near dddGravisDelay(void);
extern  void            pascal far  dddGravisStopVoice(short voice);
extern  void            pascal far  dddGravisSetVoice(short handle, short voice, short volume, short freq, short balance, short mode);
extern  long            pascal far  dddGravisRead(char voice);
extern  void            pascal far  dddGravisReset(void);
extern  short           pascal far  dddGravisPlaySound(short handle, char voice, char mode);
extern  void            pascal far  dddGravisEnable(void);
extern  void            pascal far  dddGravisDisable(void);
extern  void            pascal far  dddGravisSetFreq(char voice, short Freq);
extern  void            pascal far  dddGravisSetVolume(char voice, short Vol);
extern  void            pascal far  dddGravisPoke(long address, char sample_data);
extern  char            pascal far  dddGravisPeek(long address);
extern  short           pascal far  dddGravisSetLoop(short handle, char voice, long start, long end);
extern  char far *      pascal far  dddGravisGetInfo(short handle, struct GravisInfo far *instance);

extern  void            cdecl  far  dddEmmExit(void);
extern  void            pascal far  dddRestoreLogbase(void);
